Package com.sas.metadata.remote

# Interface TypeDefinition

All Superinterfaces:
  `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`

public interface TypeDefinition extends PrimaryType
Type definition is used to describe members of the SAS type dictionary. A type definition contains information used to describe a common or shared object type.

The Notes association will include additional configuration information and a template describing the metadata structure of the common or shared object for objects that are persisted to metadata.

Attributes of TypeDefinition are:

- `TypeName`
- `MetadataType`
- `DefaultUpdatesAllowed`
- `DefinitionVersion`
- `ApplicablePermissions`
- `DefaultIcon`
- `ContainerType`
- `DefaultLocation`
- `JavaClass`
- `ResourceTemplate`
- `AllowsChildren`
- `ContainerAssociation`
- `SupportedObjectVersionMin`
- `SupportedObjectVersionMax`

Associations of TypeDefinition are:

- `AssociatedContentType`

## Usage

To create an instance of this TypeDefinition, use the `factory` create methods.
Example: create a TypeDefinition with name "TypeDefinition_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     TypeDefinition myObject = (TypeDefinition) factory.createComplexMetadataObject(objectStore, "TypeDefinition_Object", MetadataObjects.TYPEDEFINITION, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_ASSOCIATEDCONTENTTYPE_NAME`
  Constant used for the name of the AssociatedContentType association.
  `static final String`
  `ATTRIBUTE_ALLOWSCHILDREN_NAME`
  Constant used for the name of the AllowsChildren attribute.
  `static final String`
  `ATTRIBUTE_APPLICABLEPERMISSIONS_NAME`
  Constant used for the name of the ApplicablePermissions attribute.
  `static final String`
  `ATTRIBUTE_CONTAINERASSOCIATION_NAME`
  Constant used for the name of the ContainerAssociation attribute.
  `static final String`
  `ATTRIBUTE_CONTAINERTYPE_NAME`
  Constant used for the name of the ContainerType attribute.
  `static final String`
  `ATTRIBUTE_DEFAULTICON_NAME`
  Constant used for the name of the DefaultIcon attribute.
  `static final String`
  `ATTRIBUTE_DEFAULTLOCATION_NAME`
  Constant used for the name of the DefaultLocation attribute.
  `static final String`
  `ATTRIBUTE_DEFAULTUPDATESALLOWED_NAME`
  Constant used for the name of the DefaultUpdatesAllowed attribute.
  `static final String`
  `ATTRIBUTE_DEFINITIONVERSION_NAME`
  Constant used for the name of the DefinitionVersion attribute.
  `static final String`
  `ATTRIBUTE_JAVACLASS_NAME`
  Constant used for the name of the JavaClass attribute.
  `static final String`
  `ATTRIBUTE_METADATATYPE_NAME`
  Constant used for the name of the MetadataType attribute.
  `static final String`
  `ATTRIBUTE_RESOURCETEMPLATE_NAME`
  Constant used for the name of the ResourceTemplate attribute.
  `static final String`
  `ATTRIBUTE_SUPPORTEDOBJECTVERSIONMAX_NAME`
  Constant used for the name of the SupportedObjectVersionMax attribute.
  `static final String`
  `ATTRIBUTE_SUPPORTEDOBJECTVERSIONMIN_NAME`
  Constant used for the name of the SupportedObjectVersionMin attribute.
  `static final String`
  `ATTRIBUTE_TYPENAME_NAME`
  Constant used for the name of the TypeName attribute.

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `getAllowsChildren()`
  Gets the `int` value of `AllowsChildren`
  `int`
  `getAllowsChildrenState()`
  Gets the Metadata State of `AllowsChildren`
  `String`
  `getApplicablePermissions()`
  Gets the `String` value of `ApplicablePermissions`
  `int`
  `getApplicablePermissionsMaxLength()`
  Gets the maximum length of `ApplicablePermissions`
  `int`
  `getApplicablePermissionsState()`
  Gets the Metadata State of `ApplicablePermissions`
  `ContentType`
  `getAssociatedContentType()`
  Gets the `ContentType` for `AssociatedContentType`
  `AssociationList`
  `getAssociatedContentTypes()`
  Gets the AssociationList of `AssociatedContentTypes`
  `AssociationList`
  `getAssociatedContentTypes(boolean fGoToServer)`
  Gets the Associationlist of `AssociatedContentTypes`
  `String`
  `getContainerAssociation()`
  Gets the `String` value of `ContainerAssociation`
  `int`
  `getContainerAssociationMaxLength()`
  Gets the maximum length of `ContainerAssociation`
  `int`
  `getContainerAssociationState()`
  Gets the Metadata State of `ContainerAssociation`
  `String`
  `getContainerType()`
  Gets the `String` value of `ContainerType`
  `int`
  `getContainerTypeMaxLength()`
  Gets the maximum length of `ContainerType`
  `int`
  `getContainerTypeState()`
  Gets the Metadata State of `ContainerType`
  `String`
  `getDefaultIcon()`
  Gets the `String` value of `DefaultIcon`
  `int`
  `getDefaultIconMaxLength()`
  Gets the maximum length of `DefaultIcon`
  `int`
  `getDefaultIconState()`
  Gets the Metadata State of `DefaultIcon`
  `String`
  `getDefaultLocation()`
  Gets the `String` value of `DefaultLocation`
  `int`
  `getDefaultLocationMaxLength()`
  Gets the maximum length of `DefaultLocation`
  `int`
  `getDefaultLocationState()`
  Gets the Metadata State of `DefaultLocation`
  `int`
  `getDefaultUpdatesAllowed()`
  Gets the `int` value of `DefaultUpdatesAllowed`
  `int`
  `getDefaultUpdatesAllowedState()`
  Gets the Metadata State of `DefaultUpdatesAllowed`
  `double`
  `getDefinitionVersion()`
  Gets the `double` value of `DefinitionVersion`
  `int`
  `getDefinitionVersionState()`
  Gets the Metadata State of `DefinitionVersion`
  `String`
  `getJavaClass()`
  Gets the `String` value of `JavaClass`
  `int`
  `getJavaClassMaxLength()`
  Gets the maximum length of `JavaClass`
  `int`
  `getJavaClassState()`
  Gets the Metadata State of `JavaClass`
  `String`
  `getMetadataType()`
  Gets the `String` value of `MetadataType`
  `int`
  `getMetadataTypeMaxLength()`
  Gets the maximum length of `MetadataType`
  `int`
  `getMetadataTypeState()`
  Gets the Metadata State of `MetadataType`
  `String`
  `getResourceTemplate()`
  Gets the `String` value of `ResourceTemplate`
  `int`
  `getResourceTemplateMaxLength()`
  Gets the maximum length of `ResourceTemplate`
  `int`
  `getResourceTemplateState()`
  Gets the Metadata State of `ResourceTemplate`
  `double`
  `getSupportedObjectVersionMax()`
  Gets the `double` value of `SupportedObjectVersionMax`
  `int`
  `getSupportedObjectVersionMaxState()`
  Gets the Metadata State of `SupportedObjectVersionMax`
  `double`
  `getSupportedObjectVersionMin()`
  Gets the `double` value of `SupportedObjectVersionMin`
  `int`
  `getSupportedObjectVersionMinState()`
  Gets the Metadata State of `SupportedObjectVersionMin`
  `String`
  `getTypeName()`
  Gets the `String` value of `TypeName`
  `int`
  `getTypeNameMaxLength()`
  Gets the maximum length of `TypeName`
  `int`
  `getTypeNameState()`
  Gets the Metadata State of `TypeName`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `AssociatedContentType`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setAllowsChildren(int inAllowsChildren)`
  Sets the `AllowsChildren` value and sets the state to MetadataState.LOCAL.
  `void`
  `setAllowsChildren(int inAllowsChildren, int state)`
  Sets the `AllowsChildren` Metadata State.
  `void`
  `setAllowsChildren(String inAllowsChildren)`
  Sets the `AllowsChildren` value and sets the state to MetadataState.LOCAL.
  `void`
  `setAllowsChildren(String inAllowsChildren, int state)`
  Sets the `AllowsChildren` value and Metadata State.
  `void`
  `setAllowsChildrenState(int state)`
  Sets the Metadata State of `AllowsChildren`.
  `void`
  `setApplicablePermissions(String inApplicablePermissions)`
  Sets the `ApplicablePermissions` value and sets the state to MetadataState.LOCAL.
  `void`
  `setApplicablePermissions(String inApplicablePermissions, int state)`
  Sets the `ApplicablePermissions` Metadata State.
  `void`
  `setApplicablePermissionsState(int state)`
  Sets the Metadata State of `ApplicablePermissions`.
  `void`
  `setAssociatedContentType(ContentType inObject)`
  Sets the `AssociatedContentTypes` list 0th element to be `inObject`.
  `void`
  `setAssociatedContentTypes(AssociationList list)`
  Sets the `AssociatedContentTypes` list to be `list`.
  `void`
  `setAssociatedContentTypes(AssociationList list, int state)`
  Sets the `AssociatedContentTypes` list to be `list`.
  `void`
  `setContainerAssociation(String inContainerAssociation)`
  Sets the `ContainerAssociation` value and sets the state to MetadataState.LOCAL.
  `void`
  `setContainerAssociation(String inContainerAssociation, int state)`
  Sets the `ContainerAssociation` Metadata State.
  `void`
  `setContainerAssociationState(int state)`
  Sets the Metadata State of `ContainerAssociation`.
  `void`
  `setContainerType(String inContainerType)`
  Sets the `ContainerType` value and sets the state to MetadataState.LOCAL.
  `void`
  `setContainerType(String inContainerType, int state)`
  Sets the `ContainerType` Metadata State.
  `void`
  `setContainerTypeState(int state)`
  Sets the Metadata State of `ContainerType`.
  `void`
  `setDefaultIcon(String inDefaultIcon)`
  Sets the `DefaultIcon` value and sets the state to MetadataState.LOCAL.
  `void`
  `setDefaultIcon(String inDefaultIcon, int state)`
  Sets the `DefaultIcon` Metadata State.
  `void`
  `setDefaultIconState(int state)`
  Sets the Metadata State of `DefaultIcon`.
  `void`
  `setDefaultLocation(String inDefaultLocation)`
  Sets the `DefaultLocation` value and sets the state to MetadataState.LOCAL.
  `void`
  `setDefaultLocation(String inDefaultLocation, int state)`
  Sets the `DefaultLocation` Metadata State.
  `void`
  `setDefaultLocationState(int state)`
  Sets the Metadata State of `DefaultLocation`.
  `void`
  `setDefaultUpdatesAllowed(int inDefaultUpdatesAllowed)`
  Sets the `DefaultUpdatesAllowed` value and sets the state to MetadataState.LOCAL.
  `void`
  `setDefaultUpdatesAllowed(int inDefaultUpdatesAllowed, int state)`
  Sets the `DefaultUpdatesAllowed` Metadata State.
  `void`
  `setDefaultUpdatesAllowed(String inDefaultUpdatesAllowed)`
  Sets the `DefaultUpdatesAllowed` value and sets the state to MetadataState.LOCAL.
  `void`
  `setDefaultUpdatesAllowed(String inDefaultUpdatesAllowed, int state)`
  Sets the `DefaultUpdatesAllowed` value and Metadata State.
  `void`
  `setDefaultUpdatesAllowedState(int state)`
  Sets the Metadata State of `DefaultUpdatesAllowed`.
  `void`
  `setDefinitionVersion(double inDefinitionVersion)`
  Sets the `DefinitionVersion` value and sets the state to MetadataState.LOCAL.
  `void`
  `setDefinitionVersion(double inDefinitionVersion, int state)`
  Sets the `DefinitionVersion` Metadata State.
  `void`
  `setDefinitionVersion(String inDefinitionVersion)`
  Sets the `DefinitionVersion` value and sets the state to MetadataState.LOCAL
  `void`
  `setDefinitionVersion(String inDefinitionVersion, int state)`
  Sets the `DefinitionVersion` value and Metadata State.
  `void`
  `setDefinitionVersionState(int state)`
  Sets the Metadata State of `DefinitionVersion`.
  `void`
  `setJavaClass(String inJavaClass)`
  Sets the `JavaClass` value and sets the state to MetadataState.LOCAL.
  `void`
  `setJavaClass(String inJavaClass, int state)`
  Sets the `JavaClass` Metadata State.
  `void`
  `setJavaClassState(int state)`
  Sets the Metadata State of `JavaClass`.
  `void`
  `setMetadataType(String inMetadataType)`
  Sets the `MetadataType` value and sets the state to MetadataState.LOCAL.
  `void`
  `setMetadataType(String inMetadataType, int state)`
  Sets the `MetadataType` Metadata State.
  `void`
  `setMetadataTypeState(int state)`
  Sets the Metadata State of `MetadataType`.
  `void`
  `setResourceTemplate(String inResourceTemplate)`
  Sets the `ResourceTemplate` value and sets the state to MetadataState.LOCAL.
  `void`
  `setResourceTemplate(String inResourceTemplate, int state)`
  Sets the `ResourceTemplate` Metadata State.
  `void`
  `setResourceTemplateState(int state)`
  Sets the Metadata State of `ResourceTemplate`.
  `void`
  `setSupportedObjectVersionMax(double inSupportedObjectVersionMax)`
  Sets the `SupportedObjectVersionMax` value and sets the state to MetadataState.LOCAL.
  `void`
  `setSupportedObjectVersionMax(double inSupportedObjectVersionMax, int state)`
  Sets the `SupportedObjectVersionMax` Metadata State.
  `void`
  `setSupportedObjectVersionMax(String inSupportedObjectVersionMax)`
  Sets the `SupportedObjectVersionMax` value and sets the state to MetadataState.LOCAL
  `void`
  `setSupportedObjectVersionMax(String inSupportedObjectVersionMax, int state)`
  Sets the `SupportedObjectVersionMax` value and Metadata State.
  `void`
  `setSupportedObjectVersionMaxState(int state)`
  Sets the Metadata State of `SupportedObjectVersionMax`.
  `void`
  `setSupportedObjectVersionMin(double inSupportedObjectVersionMin)`
  Sets the `SupportedObjectVersionMin` value and sets the state to MetadataState.LOCAL.
  `void`
  `setSupportedObjectVersionMin(double inSupportedObjectVersionMin, int state)`
  Sets the `SupportedObjectVersionMin` Metadata State.
  `void`
  `setSupportedObjectVersionMin(String inSupportedObjectVersionMin)`
  Sets the `SupportedObjectVersionMin` value and sets the state to MetadataState.LOCAL
  `void`
  `setSupportedObjectVersionMin(String inSupportedObjectVersionMin, int state)`
  Sets the `SupportedObjectVersionMin` value and Metadata State.
  `void`
  `setSupportedObjectVersionMinState(int state)`
  Sets the Metadata State of `SupportedObjectVersionMin`.
  `void`
  `setTypeName(String inTypeName)`
  Sets the `TypeName` value and sets the state to MetadataState.LOCAL.
  `void`
  `setTypeName(String inTypeName, int state)`
  Sets the `TypeName` Metadata State.
  `void`
  `setTypeNameState(int state)`
  Sets the Metadata State of `TypeName`.

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_TYPENAME_NAME

    static final String ATTRIBUTE_TYPENAME_NAME
    Constant used for the name of the TypeName attribute.

    TypeName: Abbreviated type name used in object URI syntax. This is usually the same as Name with any whitespace removed. Not localized. Common and shared objects of this type will use this value in their PublicType= attribute. Subtypes are identified using a dot notation. For example InformationMap.Relational and InformationMap.OLAP. Only the super type is used in the URI syntax. Subtypes must have the same top-level metadata object.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_METADATATYPE_NAME

    static final String ATTRIBUTE_METADATATYPE_NAME
    Constant used for the name of the MetadataType attribute.

    MetadataType: Metadata type used as the "top-level-object" for this logical object. For example, ClassifierMap for a stored process.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_DEFAULTUPDATESALLOWED_NAME

    static final String ATTRIBUTE_DEFAULTUPDATESALLOWED_NAME
    Constant used for the name of the DefaultUpdatesAllowed attribute.

    DefaultUpdatesAllowed: Allow clients to perform default actions such as copy, move, delete, and rename without a class handler available. The class handler should always be used when available.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_DEFINITIONVERSION_NAME

    static final String ATTRIBUTE_DEFINITIONVERSION_NAME
    Constant used for the name of the DefinitionVersion attribute.

    DefinitionVersion: Version for this type definition. Not to be confused with usage version. The type definition may change without the usage version changing. Usage version refers to how this definition is put together, not the definition itself. The definition version for this logical type definition would correlate to the usage version on a logical object. For example: I have a type definition for a stored process with a definition version of 1.0 (1000000). The definition would be applied to stored processes with a usage version of 1.0 (1000000).

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_APPLICABLEPERMISSIONS_NAME

    static final String ATTRIBUTE_APPLICABLEPERMISSIONS_NAME
    Constant used for the name of the ApplicablePermissions attribute.

    ApplicablePermissions: Comma-delimited list of permissions that apply to this logical type. The permissions listed here will be the permissions available on the auth tab for this object.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_DEFAULTICON_NAME

    static final String ATTRIBUTE_DEFAULTICON_NAME
    Constant used for the name of the DefaultIcon attribute.

    DefaultIcon: Name used by applications to lookup icons in sas.icons.jar or at a well-known http address. Individual objects may override this icon to show object state, but some applications may only show the default icon.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_CONTAINERTYPE_NAME

    static final String ATTRIBUTE_CONTAINERTYPE_NAME
    Constant used for the name of the ContainerType attribute.

    ContainerType: Typically a Folder, but may be different. For example, Column objects are contained by the object Table.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_DEFAULTLOCATION_NAME

    static final String ATTRIBUTE_DEFAULTLOCATION_NAME
    Constant used for the name of the DefaultLocation attribute.

    DefaultLocation: A SASDS URL indicating the default or recommended location for objects of this type.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_JAVACLASS_NAME

    static final String ATTRIBUTE_JAVACLASS_NAME
    Constant used for the name of the JavaClass attribute.

    JavaClass: Implementation of standard type interface.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_RESOURCETEMPLATE_NAME

    static final String ATTRIBUTE_RESOURCETEMPLATE_NAME
    Constant used for the name of the ResourceTemplate attribute.

    ResourceTemplate: SASDS URL for resource template associated with this public type.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_ALLOWSCHILDREN_NAME

    static final String ATTRIBUTE_ALLOWSCHILDREN_NAME
    Constant used for the name of the AllowsChildren attribute.

    AllowsChildren: This object type may act as a container for other common or shared objects.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_CONTAINERASSOCIATION_NAME

    static final String ATTRIBUTE_CONTAINERASSOCIATION_NAME
    Constant used for the name of the ContainerAssociation attribute.

    ContainerAssociation: The association used to find the container for this common or shared object.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_SUPPORTEDOBJECTVERSIONMIN_NAME

    static final String ATTRIBUTE_SUPPORTEDOBJECTVERSIONMIN_NAME
    Constant used for the name of the SupportedObjectVersionMin attribute.

    SupportedObjectVersionMin: Type definitions may support a range of versions. This value specifies the minimum version supported by this definition. Applications that need to determine which type definition to use need to look at the value in an object's UsageVersion= attribute and find the definition that supports the object.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_SUPPORTEDOBJECTVERSIONMAX_NAME

    static final String ATTRIBUTE_SUPPORTEDOBJECTVERSIONMAX_NAME
    Constant used for the name of the SupportedObjectVersionMax attribute.

    SupportedObjectVersionMax: The maximum object version supported by this definition.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_ASSOCIATEDCONTENTTYPE_NAME

    static final String ASSOCIATION_ASSOCIATEDCONTENTTYPE_NAME
    Constant used for the name of the AssociatedContentType association.

    AssociatedContentType: Type of content represented by this type definition.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `AssociatedContentType`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getTypeName

    String getTypeName() throws RemoteException
    Gets the `String` value of `TypeName`
    Returns:
      The `TypeName`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getTypeNameState

    int getTypeNameState() throws RemoteException
    Gets the Metadata State of `TypeName`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getTypeNameMaxLength

    int getTypeNameMaxLength() throws RemoteException
    Gets the maximum length of `TypeName`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getMetadataType

    String getMetadataType() throws RemoteException
    Gets the `String` value of `MetadataType`
    Returns:
      The `MetadataType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getMetadataTypeState

    int getMetadataTypeState() throws RemoteException
    Gets the Metadata State of `MetadataType`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getMetadataTypeMaxLength

    int getMetadataTypeMaxLength() throws RemoteException
    Gets the maximum length of `MetadataType`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDefaultUpdatesAllowed

    int getDefaultUpdatesAllowed() throws RemoteException
    Gets the `int` value of `DefaultUpdatesAllowed`
    Returns:
      The `DefaultUpdatesAllowed`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDefaultUpdatesAllowedState

    int getDefaultUpdatesAllowedState() throws RemoteException
    Gets the Metadata State of `DefaultUpdatesAllowed`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDefinitionVersion

    double getDefinitionVersion() throws RemoteException
    Gets the `double` value of `DefinitionVersion`
    Returns:
      The `DefinitionVersion`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDefinitionVersionState

    int getDefinitionVersionState() throws RemoteException
    Gets the Metadata State of `DefinitionVersion`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getApplicablePermissions

    String getApplicablePermissions() throws RemoteException
    Gets the `String` value of `ApplicablePermissions`
    Returns:
      The `ApplicablePermissions`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getApplicablePermissionsState

    int getApplicablePermissionsState() throws RemoteException
    Gets the Metadata State of `ApplicablePermissions`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getApplicablePermissionsMaxLength

    int getApplicablePermissionsMaxLength() throws RemoteException
    Gets the maximum length of `ApplicablePermissions`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDefaultIcon

    String getDefaultIcon() throws RemoteException
    Gets the `String` value of `DefaultIcon`
    Returns:
      The `DefaultIcon`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDefaultIconState

    int getDefaultIconState() throws RemoteException
    Gets the Metadata State of `DefaultIcon`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDefaultIconMaxLength

    int getDefaultIconMaxLength() throws RemoteException
    Gets the maximum length of `DefaultIcon`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getContainerType

    String getContainerType() throws RemoteException
    Gets the `String` value of `ContainerType`
    Returns:
      The `ContainerType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getContainerTypeState

    int getContainerTypeState() throws RemoteException
    Gets the Metadata State of `ContainerType`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getContainerTypeMaxLength

    int getContainerTypeMaxLength() throws RemoteException
    Gets the maximum length of `ContainerType`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDefaultLocation

    String getDefaultLocation() throws RemoteException
    Gets the `String` value of `DefaultLocation`
    Returns:
      The `DefaultLocation`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDefaultLocationState

    int getDefaultLocationState() throws RemoteException
    Gets the Metadata State of `DefaultLocation`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDefaultLocationMaxLength

    int getDefaultLocationMaxLength() throws RemoteException
    Gets the maximum length of `DefaultLocation`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getJavaClass

    String getJavaClass() throws RemoteException
    Gets the `String` value of `JavaClass`
    Returns:
      The `JavaClass`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getJavaClassState

    int getJavaClassState() throws RemoteException
    Gets the Metadata State of `JavaClass`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getJavaClassMaxLength

    int getJavaClassMaxLength() throws RemoteException
    Gets the maximum length of `JavaClass`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getResourceTemplate

    String getResourceTemplate() throws RemoteException
    Gets the `String` value of `ResourceTemplate`
    Returns:
      The `ResourceTemplate`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getResourceTemplateState

    int getResourceTemplateState() throws RemoteException
    Gets the Metadata State of `ResourceTemplate`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getResourceTemplateMaxLength

    int getResourceTemplateMaxLength() throws RemoteException
    Gets the maximum length of `ResourceTemplate`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getAllowsChildren

    int getAllowsChildren() throws RemoteException
    Gets the `int` value of `AllowsChildren`
    Returns:
      The `AllowsChildren`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getAllowsChildrenState

    int getAllowsChildrenState() throws RemoteException
    Gets the Metadata State of `AllowsChildren`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getContainerAssociation

    String getContainerAssociation() throws RemoteException
    Gets the `String` value of `ContainerAssociation`
    Returns:
      The `ContainerAssociation`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getContainerAssociationState

    int getContainerAssociationState() throws RemoteException
    Gets the Metadata State of `ContainerAssociation`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getContainerAssociationMaxLength

    int getContainerAssociationMaxLength() throws RemoteException
    Gets the maximum length of `ContainerAssociation`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSupportedObjectVersionMin

    double getSupportedObjectVersionMin() throws RemoteException
    Gets the `double` value of `SupportedObjectVersionMin`
    Returns:
      The `SupportedObjectVersionMin`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSupportedObjectVersionMinState

    int getSupportedObjectVersionMinState() throws RemoteException
    Gets the Metadata State of `SupportedObjectVersionMin`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSupportedObjectVersionMax

    double getSupportedObjectVersionMax() throws RemoteException
    Gets the `double` value of `SupportedObjectVersionMax`
    Returns:
      The `SupportedObjectVersionMax`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSupportedObjectVersionMaxState

    int getSupportedObjectVersionMaxState() throws RemoteException
    Gets the Metadata State of `SupportedObjectVersionMax`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getAssociatedContentTypes

    AssociationList getAssociatedContentTypes() throws RemoteException, MdException
    Gets the AssociationList of `AssociatedContentTypes`
    Returns:
      Returns the AssociationList of `AssociatedContentTypes` which can be of type:
      ContentType
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getAssociatedContentType

    ContentType getAssociatedContentType() throws RemoteException, MdException
    Gets the `ContentType` for `AssociatedContentType`
    Returns:
      The `ContentType` ( `null` if not set) of `AssociatedContentType`which can be of type:
      ContentType
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedContentTypes

    AssociationList getAssociatedContentTypes(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `AssociatedContentTypes`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `AssociatedContentTypes` which can be of type:
      ContentType
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setTypeName

    void setTypeName(String inTypeName) throws RemoteException
    Sets the `TypeName` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inTypeName` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTypeName

    void setTypeName(String inTypeName, int state) throws RemoteException
    Sets the `TypeName` Metadata State.
    Parameters:
      `inTypeName` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTypeNameState

    void setTypeNameState(int state) throws RemoteException
    Sets the Metadata State of `TypeName`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setMetadataType

    void setMetadataType(String inMetadataType) throws RemoteException
    Sets the `MetadataType` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inMetadataType` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setMetadataType

    void setMetadataType(String inMetadataType, int state) throws RemoteException
    Sets the `MetadataType` Metadata State.
    Parameters:
      `inMetadataType` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setMetadataTypeState

    void setMetadataTypeState(int state) throws RemoteException
    Sets the Metadata State of `MetadataType`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefaultUpdatesAllowed

    void setDefaultUpdatesAllowed(int inDefaultUpdatesAllowed) throws RemoteException
    Sets the `DefaultUpdatesAllowed` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inDefaultUpdatesAllowed` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefaultUpdatesAllowed

    void setDefaultUpdatesAllowed(int inDefaultUpdatesAllowed, int state) throws RemoteException
    Sets the `DefaultUpdatesAllowed` Metadata State.
    Parameters:
      `inDefaultUpdatesAllowed` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefaultUpdatesAllowed

    void setDefaultUpdatesAllowed(String inDefaultUpdatesAllowed) throws RemoteException
    Sets the `DefaultUpdatesAllowed` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inDefaultUpdatesAllowed` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefaultUpdatesAllowed

    void setDefaultUpdatesAllowed(String inDefaultUpdatesAllowed, int state) throws RemoteException
    Sets the `DefaultUpdatesAllowed` value and Metadata State.
    Parameters:
      `inDefaultUpdatesAllowed` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefaultUpdatesAllowedState

    void setDefaultUpdatesAllowedState(int state) throws RemoteException
    Sets the Metadata State of `DefaultUpdatesAllowed`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefinitionVersion

    void setDefinitionVersion(double inDefinitionVersion) throws RemoteException
    Sets the `DefinitionVersion` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inDefinitionVersion` - double
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefinitionVersion

    void setDefinitionVersion(double inDefinitionVersion, int state) throws RemoteException
    Sets the `DefinitionVersion` Metadata State.
    Parameters:
      `inDefinitionVersion` - double
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefinitionVersion

    void setDefinitionVersion(String inDefinitionVersion) throws RemoteException
    Sets the `DefinitionVersion` value and sets the state to MetadataState.LOCAL
    Parameters:
      `inDefinitionVersion` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefinitionVersion

    void setDefinitionVersion(String inDefinitionVersion, int state) throws RemoteException
    Sets the `DefinitionVersion` value and Metadata State.
    Parameters:
      `inDefinitionVersion` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefinitionVersionState

    void setDefinitionVersionState(int state) throws RemoteException
    Sets the Metadata State of `DefinitionVersion`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setApplicablePermissions

    void setApplicablePermissions(String inApplicablePermissions) throws RemoteException
    Sets the `ApplicablePermissions` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inApplicablePermissions` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setApplicablePermissions

    void setApplicablePermissions(String inApplicablePermissions, int state) throws RemoteException
    Sets the `ApplicablePermissions` Metadata State.
    Parameters:
      `inApplicablePermissions` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setApplicablePermissionsState

    void setApplicablePermissionsState(int state) throws RemoteException
    Sets the Metadata State of `ApplicablePermissions`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefaultIcon

    void setDefaultIcon(String inDefaultIcon) throws RemoteException
    Sets the `DefaultIcon` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inDefaultIcon` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefaultIcon

    void setDefaultIcon(String inDefaultIcon, int state) throws RemoteException
    Sets the `DefaultIcon` Metadata State.
    Parameters:
      `inDefaultIcon` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefaultIconState

    void setDefaultIconState(int state) throws RemoteException
    Sets the Metadata State of `DefaultIcon`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setContainerType

    void setContainerType(String inContainerType) throws RemoteException
    Sets the `ContainerType` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inContainerType` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setContainerType

    void setContainerType(String inContainerType, int state) throws RemoteException
    Sets the `ContainerType` Metadata State.
    Parameters:
      `inContainerType` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setContainerTypeState

    void setContainerTypeState(int state) throws RemoteException
    Sets the Metadata State of `ContainerType`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefaultLocation

    void setDefaultLocation(String inDefaultLocation) throws RemoteException
    Sets the `DefaultLocation` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inDefaultLocation` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefaultLocation

    void setDefaultLocation(String inDefaultLocation, int state) throws RemoteException
    Sets the `DefaultLocation` Metadata State.
    Parameters:
      `inDefaultLocation` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefaultLocationState

    void setDefaultLocationState(int state) throws RemoteException
    Sets the Metadata State of `DefaultLocation`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setJavaClass

    void setJavaClass(String inJavaClass) throws RemoteException
    Sets the `JavaClass` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inJavaClass` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setJavaClass

    void setJavaClass(String inJavaClass, int state) throws RemoteException
    Sets the `JavaClass` Metadata State.
    Parameters:
      `inJavaClass` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setJavaClassState

    void setJavaClassState(int state) throws RemoteException
    Sets the Metadata State of `JavaClass`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setResourceTemplate

    void setResourceTemplate(String inResourceTemplate) throws RemoteException
    Sets the `ResourceTemplate` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inResourceTemplate` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setResourceTemplate

    void setResourceTemplate(String inResourceTemplate, int state) throws RemoteException
    Sets the `ResourceTemplate` Metadata State.
    Parameters:
      `inResourceTemplate` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setResourceTemplateState

    void setResourceTemplateState(int state) throws RemoteException
    Sets the Metadata State of `ResourceTemplate`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAllowsChildren

    void setAllowsChildren(int inAllowsChildren) throws RemoteException
    Sets the `AllowsChildren` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inAllowsChildren` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAllowsChildren

    void setAllowsChildren(int inAllowsChildren, int state) throws RemoteException
    Sets the `AllowsChildren` Metadata State.
    Parameters:
      `inAllowsChildren` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAllowsChildren

    void setAllowsChildren(String inAllowsChildren) throws RemoteException
    Sets the `AllowsChildren` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inAllowsChildren` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAllowsChildren

    void setAllowsChildren(String inAllowsChildren, int state) throws RemoteException
    Sets the `AllowsChildren` value and Metadata State.
    Parameters:
      `inAllowsChildren` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAllowsChildrenState

    void setAllowsChildrenState(int state) throws RemoteException
    Sets the Metadata State of `AllowsChildren`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setContainerAssociation

    void setContainerAssociation(String inContainerAssociation) throws RemoteException
    Sets the `ContainerAssociation` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inContainerAssociation` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setContainerAssociation

    void setContainerAssociation(String inContainerAssociation, int state) throws RemoteException
    Sets the `ContainerAssociation` Metadata State.
    Parameters:
      `inContainerAssociation` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setContainerAssociationState

    void setContainerAssociationState(int state) throws RemoteException
    Sets the Metadata State of `ContainerAssociation`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSupportedObjectVersionMin

    void setSupportedObjectVersionMin(double inSupportedObjectVersionMin) throws RemoteException
    Sets the `SupportedObjectVersionMin` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inSupportedObjectVersionMin` - double
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSupportedObjectVersionMin

    void setSupportedObjectVersionMin(double inSupportedObjectVersionMin, int state) throws RemoteException
    Sets the `SupportedObjectVersionMin` Metadata State.
    Parameters:
      `inSupportedObjectVersionMin` - double
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSupportedObjectVersionMin

    void setSupportedObjectVersionMin(String inSupportedObjectVersionMin) throws RemoteException
    Sets the `SupportedObjectVersionMin` value and sets the state to MetadataState.LOCAL
    Parameters:
      `inSupportedObjectVersionMin` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSupportedObjectVersionMin

    void setSupportedObjectVersionMin(String inSupportedObjectVersionMin, int state) throws RemoteException
    Sets the `SupportedObjectVersionMin` value and Metadata State.
    Parameters:
      `inSupportedObjectVersionMin` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSupportedObjectVersionMinState

    void setSupportedObjectVersionMinState(int state) throws RemoteException
    Sets the Metadata State of `SupportedObjectVersionMin`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSupportedObjectVersionMax

    void setSupportedObjectVersionMax(double inSupportedObjectVersionMax) throws RemoteException
    Sets the `SupportedObjectVersionMax` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inSupportedObjectVersionMax` - double
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSupportedObjectVersionMax

    void setSupportedObjectVersionMax(double inSupportedObjectVersionMax, int state) throws RemoteException
    Sets the `SupportedObjectVersionMax` Metadata State.
    Parameters:
      `inSupportedObjectVersionMax` - double
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSupportedObjectVersionMax

    void setSupportedObjectVersionMax(String inSupportedObjectVersionMax) throws RemoteException
    Sets the `SupportedObjectVersionMax` value and sets the state to MetadataState.LOCAL
    Parameters:
      `inSupportedObjectVersionMax` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSupportedObjectVersionMax

    void setSupportedObjectVersionMax(String inSupportedObjectVersionMax, int state) throws RemoteException
    Sets the `SupportedObjectVersionMax` value and Metadata State.
    Parameters:
      `inSupportedObjectVersionMax` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSupportedObjectVersionMaxState

    void setSupportedObjectVersionMaxState(int state) throws RemoteException
    Sets the Metadata State of `SupportedObjectVersionMax`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedContentTypes

    void setAssociatedContentTypes(AssociationList list) throws RemoteException
    Sets the `AssociatedContentTypes` list to be `list`. Object of which can be of type:
    ContentType
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedContentTypes

    void setAssociatedContentTypes(AssociationList list, int state) throws RemoteException
    Sets the `AssociatedContentTypes` list to be `list`. Object of which can be of type:
    ContentType
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedContentType

    void setAssociatedContentType(ContentType inObject) throws RemoteException
    Sets the `AssociatedContentTypes` list 0th element to be `inObject`.
    Parameters:
      `inObject` - ContentType
    Throws:
      `RemoteException` - If error communicating with remote object.